#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: sql_debug.tcl,v 1.3 2000/09/28 18:23:33 artur Exp $
#
# Information:
# Modul (benutzt von Schema Editor)
# Ein XWindows(Tk) Sql Debugger

if {![winfo exist .sqlmonitor]} {
    toplevel .sqlmonitor
    tixScrolledText .sqlmonitor.st
    checkbutton .sqlmonitor.check -text "Check before Apply" -variable MySql::waitforapply
    checkbutton .sqlmonitor.prot -text "Protokolieren" -variable MySql::prot
    button .sqlmonitor.apply -text "Apply" -command "set MySql::applyvar 1" -state disabled 
    button .sqlmonitor.reject -text "Reeject SQL" -command "set MySql::applyvar 0" -state disabled 
    pack  .sqlmonitor.st -expand yes -fill both
    pack  .sqlmonitor.check .sqlmonitor.prot .sqlmonitor.apply .sqlmonitor.reject -anchor w
} else {
    return
}

Sqlinterface instproc monitorFilter args {
    if {[lcontain {query execute} [[self] info calledproc]]}  {
	if {!$MySql::prot} {
	    .sqlmonitor.st subwidget text delete 1.0 end
	} else {
	    .sqlmonitor.st subwidget text insert end "\n"
	}
	.sqlmonitor.st subwidget text insert end [lindex $args 0]
	if {$MySql::waitforapply} {
	    .sqlmonitor.apply configure -state normal  
	    .sqlmonitor.reject configure -state normal    
	    tkwait variable MySql::applyvar
	    .sqlmonitor.apply configure -state disabled
	    .sqlmonitor.reject configure -state normal  
	    if {!$MySql::applyvar} { return }
	}
    }
    [self] next
}
MySql filter Sqlinterface::monitorFilter
PgSql filter Sqlinterface::monitorFilter
