#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: win_inspector.tcl,v 1.3 2000/09/28 18:23:12 artur Exp $
#
# Information:
# Fr Debugging
# Dieses Program sollte aus einer laufender
# tix Applikations gestartet werden
# Es zeigt die Komplete Widget (Windows) Baum Struktur

proc mapwininspector {} {
    destroy .winspector
    set S [toplevel .wininspector -width 400 -height 400]
    frame $S.bframe
    button $S.bframe.drawGraph -command drawwins -text drawGraph
    tixScrolledListBox $S.bframe.lt
    tixTree $S.mtree -command {wins_showconfigure} -options {
	hlist.separator "."
	hlist.width 35
	hlist.height 25
    }
    pack $S.bframe.drawGraph  -side top -anchor n
    pack $S.bframe.lt  -side top -anchor n -fill both -expand yes
    pack $S.bframe $S.mtree -side right -expand yes -fill both
    drawwins
}
proc drawwins {} {
    set winlist [tixDescendants .]
    set hlist [.wininspector.mtree subwidget hlist]
    $hlist delete all
    foreach win $winlist {    
	if {[string match winspector* $win]} { continue } 
	$hlist add $win -itemtype text \
	    -text "[winfo name $win] [winfo class $win]"
    }
    .wininspector.mtree autosetmode 
}
proc wins_showconfigure elem {
    set tlist [.wininspector.bframe.lt subwidget listbox]
    $tlist delete 0 end
    foreach conf [$elem configure] {
	$tlist insert end "[lindex $conf 0] = [lindex $conf 4]"
    }
}
mapwininspector
